(***********************************************************************)
(*                                                                     *)
(*                       Ambients in JoCaml                            *)
(*                                                                     *)
(*               Alan Schmitt, projet Para, INRIA Rocquencourt         *)
(*                                                                     *)
(*  Copyright 1999 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

type 'a 'b t

(* key-value table, with a single entry per key *)

val create : unit -> 'a 'b t;
val add    : 'a 'b t -> 'a -> 'b -> unit;

  (* empty the table, calling a terminator; 
     later on the table should not be used anymore *)

val flush  : 'a 'b t -> ('a -> 'b -> unit) -> unit

val find        : 'a 'b t -> 'a -> 'b   (* may raise Not_found *)
val remove      : 'a 'b t -> 'a -> unit (* may raise Not_found *)
val find_remove : 'a 'b t -> 'a -> 'b   (* may raise Not_found *)

